<template>
  <v-card 
		class="fill-height "
		>
		<v-toolbar
		dark
		color="brown"
		>

		<v-btn
		icon
		dark
		v-on:click.native="close"
		>
			<v-icon>mdi-close</v-icon>
		</v-btn>
			<v-toolbar-title class="title white--text pl-0">
				{{page_title}}
			</v-toolbar-title>
		</v-toolbar>
		<v-row class="no-gutters">
			<v-col
			cols="3"
			class="flex-grow-1 flex-shrink-0"
			style="border-right: 1px solid #0000001f;"
			>
			<v-responsive
				class="overflow-y-auto fill-height"
				height="550"
			>
				<chat-member-list :portal="members"/>
			</v-responsive>
			</v-col>
			<v-col
			cols="9"
			class="flex-grow-1 flex-shrink-0"
			>
			<v-responsive
				v-if="activeChat"
				class="overflow-y-hidden fill-height"
				height="500"
			>
				<v-card
				flat
				class="d-flex flex-column fill-height"
				>
				<v-card-title>
					{{page_title}}
				</v-card-title>
				<v-card-text class="flex-grow-1 overflow-y-auto" ref="scrollable">
					<span v-for="(chat, i) in chats" v-bind:key="i">
						<chat-buble :portal="chat"></chat-buble>
					</span>
				</v-card-text>
				<v-card-text class="flex-shrink-1">
					<v-text-field
						v-model="subject"
						label="type_a_message"
						type="text"
						no-details
						outlined
						append-outer-icon="mdi-message"					
						hide-details
						v-on:keypress.enter="handleInput($event)"
					/>
				</v-card-text>
				</v-card>
			</v-responsive>
			</v-col>
		</v-row>
	</v-card>
</template>

<script>
import {mapGetters, mapActions} from 'vuex'
import chatComponent from './ChatBuble.vue'
import membersComponent from './ChatMemberList.vue'

export default {
	name:'chat-room',
	components:{
		'chat-buble':chatComponent,
		'chat-member-list':membersComponent
		},
	data(){
		return{
			activeChat:true,
			page_title:'Chat room',
			subject:'',
			textMessage:'',
			chats:[],
			members:[],
			channel:null					
		}
	},methods:{		
		async loadChats(){
			try {
				let response = await axios.get('/api/chat',this.getHeader())
				if(response.status==200){
					let{data} = response.data
					this.chats = data
				}
			} catch (err) {
				
				console.log(err)

			}
		},
		handleInput(e){

			console.log('Send Message .... ')

			if(e.keyCode===13 && !e.shiftKey){

				e.preventDefault()

				if(this.subject.trim()==='')
					return
				else	
					this.sendMessage()
			}

		},
		async sendMessage(){
			try{

				let response = await axios.post('/api/chat/send',this.getForm(),this.getHeader()) 

				if(response.status==201){
					
					let {response_code, data} = response.data

					if(response_code==="00"){
						
						console.log('push data to the list')

						this.chats.push(data)
						this.subject = ''
						this.textMessage = ''
						this.scrollToBottom()

					}

				}

			}catch(err){

				console.log(err)

			}
		},
		close(){			  			  
			  window.Echo.leave('Crowd-Funding-Chat-C')
			  this.channel=null
			  this.$router.push({name:'home'})
		},
		getForm(){
			let form = new FormData()
			form.append('subject',this.subject.trim())			
			form.append('user_email',this.loggedInUser.email)

			return form 
		},
		getHeader:function(){
			return{
				headers:{
					'Accept': 'application/json',
					'Access-Control-Allow-Headers': 'Authorization',
					'Authorization':`Bearer ${this.token}`
				}
			}
		},
		scrollToBottom(){
			/* setTimeout(function(){
				console.log('scrollItem')				
				let scrollItem = this.$refs.scrollable
				console.log('scrollItem')
				console.log(scrollItem)
				scrollItem.scrollTop = scrollItem.scrollHeight 
			},3) */
		},
		initiateListener(){
			this.channel = Echo.join('Crowd-Funding-Chat-C')			
			
			.here((users)=>{
				console.log("all users now!")
				console.log(users)
				this.members = users
			})
			.joining((user)=>{
				console.log("User join now!")
				console.log(user)
				this.members.push(user)

			})
			.leaving((user)=>{
				console.log("User leaving now!")
				console.log(user)
				this.members = this.members.filter((u)=>{
					return u.id != user.id
				})
			})			
			.listen('crowdfunding\\ChatStoredEvent', (e) => {
				
				console.log(e)

				let {chat} = e

				this.chats.push(chat)

				});
				console.log('Chat Listener establised')
			}

	},computed:{
		...mapGetters({
			loggedInUser:'authenticate/whoAmI',
			token:'authenticate/haveToken'
		})
		
	},mounted(){
		console.log('Chat Mounted')
		this.loadChats()
		this.scrollToBottom()
		this.initiateListener()
	}
}
</script>

<style>

</style>